<?php

  class mw_upgrade_index extends mw_controller{

    public function index(){
      $env = $this->env();
      $data = $env->data();
      $env->set_out("data_version", $data->version("mtweb"));
      $env->set_out("env_version", $env->version("mtweb"));
      $env->set_out("data_upgrades", $env->data_upgrades());
    }

    public function confirm_upgrade(){
      $env = $this->env();
      if(!($user = $env->user())){
        $env->redirect($env->url("upgrade"), "", 0);
        return;
      }
      if(($res = $env->do_data_upgrade()) !== true){
        $env->erreur("Erreur durant l'upgrade: ".$res);
        return;
      }
      $env->redirect(
        $env->url(),
        "La base a été mise à jour"
      );
    }

  }
