<?php

  class mw_data_valid_config extends mw_data{

    public function valid_config($input, $config = array()){
      $res = array(
        "config" => $config,
        "messages" => array(),
        "erreurs" => array()
      );
      if(isset($input["site_name"])) $res["config"]["site_name"] = $input["site_name"];
      if(isset($input["description"])) $res["config"]["description"] = $input["description"];
      if(isset($input["max_list"]) && $input["max_list"]){
        $res["config"]["max_list"] = $input["max_list"];
        if(!preg_match("/^[0-9]+$/", $res["config"]["max_list"])){
          $res["messages"][] = "la taille maximum des listes doit être un nombre";
        }
      }
      else $res["config"]["max_list"] = "";
      if(isset($input["contact_form"]) && $input["contact_form"]){
        $res["config"]["contact_form"] = "1";
        if(!isset($input["email"]) || !trim($input["email"])){
          $res["messages"][] = "merci de préciser un email pour le formulaire de contact";
        }
      }
      else $res["config"]["contact_form"] = "0";
      if(isset($input["email"])) $res["config"]["email"] = trim($input["email"]);
      if(isset($input["captcha"]) && $input["captcha"]) $res["config"]["captcha"] = "1";
      else $res["config"]["captcha"] = "0";
      return $res;
    }

  }
