<?php

  class mw_admin_sourceml extends mw_controller{

    public $groupes;
    public $albums;
    public $status;
    public $album_status_id;

    public function validate(){
      $env = $this->env();
      $data = $env->data();
      if(($this->status = $data->source_status()) === false){
        return "Impossible de lire la liste des status de source";
      }
      foreach($this->status as $id_source_status => $source_status){
        if($source_status["nom"] == "album") $this->album_status_id = $id_source_status;
        if(isset($this->album_status_id) && isset($this->morceau_status_id)) break;
      }
      if(!isset($this->album_status_id)) return "Type de source inconnu: album";
      if(($this->groupes = $data->groupes()) === false){
        return "Impossible de lire la liste des groupes";
      }
      $select = array("status" => $this->album_status_id);
      if(($this->albums = $data->sources($select)) === false){
        return "impossible de lire la liste des albums";
      }
      return true;
    }

    public function index(){
      $env = $this->env();
      $data = $env->data();
      if(!($groupes = $this->groupes)){
        $env->erreur("Impossible de lire la liste des groupes");
        return;
      }
      if(!($albums = $this->albums)){
        $env->erreur("Impossible de lire la liste des albums");
        return;
      }
      if(($CONFIG = $env->get_CONFIG()) === false){
        $env->erreur("Impossible de lire la configuration");
        return;
      }
      if($_POST){
        if($_POST["start_action"] == "sources/groupe"){
          if(!$data->set_config("start_action", "sources/groupe")){
            $env->erreur("impossible d'enregistrer la configuration");
            return;
          }
        }
        elseif($_POST["start_action"] == "sources/groupe/view"){
          $params = array("id" => $_POST["groupe_param"]);
          if(
                !$data->set_config("start_action", "sources/groupe/view")
            ||  !$data->set_config("start_action_params", @serialize($params))
          ){
            $env->erreur("impossible d'enregistrer la configuration");
            return;
          }
        }
        elseif($_POST["start_action"] == "sources/album/view"){
          $params = array("album" => $_POST["album_param"]);
          if(
                !$data->set_config("start_action", "sources/album/view")
            ||  !$data->set_config("start_action_params", @serialize($params))
          ){
            $env->erreur("impossible d'enregistrer la configuration");
            return;
          }
        }
        elseif(
              isset($CONFIG["start_action"])
          &&  (
                ($CONFIG["start_action"] == "sources/groupe")
            ||  ($CONFIG["start_action"] == "sources/groupe/view")
            ||  ($CONFIG["start_action"] == "sources/album/view")
          )
        ){
          if(!$data->set_config("start_action", "")){
            $env->erreur("impossible d'enregistrer la configuration");
            return;
          }
        }
        $env->redirect(
          $env->url("admin/sourceml"),
          "la configuration a été enregistrée"
        );
      }
      $env->set_out("groupes", $this->groupes);
      $env->set_out("albums", $this->albums);
      $env->set_out("config", $CONFIG);
    }

  }
